
<template>
  <div id="Login">
    <span>
      <h1>The RPG</h1>
      <h2 style="opacity: 0.7">OF THE APOCALYPSE</h2>
    </span>
    <form class="panel" @submit.prevent="login">
      <h3>Login</h3>
      Username
      <input :id="userNameInputHtmlIdName" type="text" v-model="username" autofocus />
      Password
      <input type="password" v-model="password" />
      <input type="submit" hidden />
    </form>

    <!-- Temporary -->
    Log as "admin" to access the admin page
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue } from "vue-property-decorator";
import { login as backendLoging, UserRole } from "@/services/backends/users";
import store from "@/store";
import { commit, MessageType } from "@/store/messages";

@Component
export default class Login extends Vue {
  private userNameInputHtmlIdName = "userNameInput";
  private username = "";
  private password = "";

  mounted(): void {
    document.getElementById(this.userNameInputHtmlIdName)?.focus();
  }

  async login(): Promise<void> {
    const user = await backendLoging(this.username, this.password);

    if (user && store.state.user.user) {
      store.commit(commit.display, {
        type: MessageType.White,
        title: `Welcome ${store.state.user.user.username}!`
      });
      if (user.role === UserRole.USER) this.$router.push("/games");
      if (user.role === UserRole.ADMIN) this.$router.push("/admin");
    }
    this.password = "";
  }
}
</script>

<style scoped>
#Login {
  height: 100%;
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  gap: 70px;
}
#Login form {
  display: flex;
  flex-direction: column;
  gap: 4px;
  padding: 8px;
}
</style>
